//=============================================================================
// Employee Button.
//=============================================================================
class EmployeeButtonC extends DeusExDecoration;

var() float buttonLitTime;
var() sound buttonSound1;
var() sound buttonSound2;
var() bool bLit;
var() bool bWaitForEvent;
var bool isPressed;

var Vector	lastLoc, rpcLocation;
var bool		bIsMoving;

var float MinuteTimer;
var() int PayPerMinute;
var() JobButtonC ToMonitorC;
var() EmployeeButtonC FellowEmployees[2]; //added so people don't get paid double.
var() bool bModLooks;
var() texture JobClothes[8];
var() mesh JobMesh;
var() localized string StoreName; //human readable name
var() localized string Shopstring; //job button readable name
var DeusExPlayer ShopOwner;

replication 
{
	reliable if ( Role == ROLE_Authority )
		rpcLocation;
}

function Frob(Actor Frobber, Inventory frobWith)
{
local Actor A;
local DeusExPlayer P;

  P = DeusExPlayer(Frobber);

     Super.Frob(Frobber, frobwith);

    if (ToMonitorC.ShopOwner != None)
    {
     if (ShopOwner != P)
     {
     if ((FellowEmployees[0].ShopOwner == P) || (FellowEmployees[1].ShopOwner == P))
     {
      P.ClientMessage("|p2You already have a job at the "$StoreName$"!");
      return;
     }
     ShopOwner.ClientMessage("|p2"$P.PlayerReplicationInfo.PlayerName$" has taken over Your job at the "$StoreName$"!");
     ShopOwner = P;
     SetTimer(60, False);
     BroadcastMessage("|p3"$P.PlayerReplicationInfo.PlayerName$"|p4 is now employed at the "$StoreName$"|p4 at the pay rate of |p3"$PayPerMinute$" dollars per minute!", true, 'CriticalEvent'); // Broadcast message to all players.
//     MinuteTimer = 60;
     if (bModLooks)
     {
     P.MultiSkins[0] = JobClothes[0];
     P.MultiSkins[1] = JobClothes[1];
     P.MultiSkins[2] = JobClothes[2];
     P.MultiSkins[3] = JobClothes[3];
     P.MultiSkins[4] = JobClothes[4];
     P.MultiSkins[5] = JobClothes[5];
     P.MultiSkins[6] = JobClothes[6];
     P.MultiSkins[7] = JobClothes[7];
     P.Mesh = JobMesh;
     }
     return;
     }
     if (ShopOwner == P)
     {
     ShopOwner = None;
     SetTimer(1, False);
     BroadcastMessage("|p3"$P.PlayerReplicationInfo.PlayerName$"|p4 has just resigned from their job at the |cf88"$StoreName$"!", true, 'CriticalEvent'); // Broadcast message to all players.
     return;
     }
    }
    if (ToMonitorC.ShopOwner == None)
     P.ClientMessage("|p2No one owns the shop!");
}

singular function SupportActor(Actor standingActor)
{
	// do nothing
}

function Bump(actor Other)
{
	// do nothing
}

simulated function Tick( float deltaTime )
{						  	
	if ( Level.NetMode != NM_Standalone )
	{
		if ( Role == ROLE_Authority )
		{
			// Was moving, now at rest
			if ( bIsMoving && ( Location == lastLoc ))
				rpcLocation = Location;

			bIsMoving = ( Location != lastLoc );
			lastLoc = Location;
		}
		else
		{
			// Our replicated location changed which means the button has come to rest
			if ( lastLoc != rpcLocation )
			{
				SetLocation( rpcLocation );
				lastLoc = rpcLocation;
			}
		}
	}

        //MinuteTimer -= DeltaTime;
        
        /*if (MinuteTimer <= 0)
        {
          if (ToMonitorC.ShopOwner.Credits >= PayPerMinute)
          {
           ShopOwner.Credits += PayPerMinute;
           ShopOwner.ClientMessage("|p3You have just been paid your minutely salary of "$PayPerMinute$"!");
           ToMonitorC.ShopOwner.Credits -= PayPerMinute;
           ToMonitorC.ShopOwner.ClientMessage("|cf88"$ShopOwner.PlayerReplicationInfo.PlayerName$" has been paid their minutely salary of "$PayPerMinute$"! |p2NOTE THIS MONEEY COMES FROM YOU.");
           MinuteTimer = 60;    
          }
          else
          {
           ShopOwner.ClientMessage("|p2You have been fired because your boss cannot afford to pay you");
           ShopOwner = None;
           ToMonitorC.ShopOwner.ClientMessage("|p2An employee has just been fired because you cannot afford to pay them!");
          }
        }*/

	Super.Tick( deltaTime );
}

function Timer()
{
	  if (ShopOwner != None)
          {
           ShopOwner.Credits += PayPerMinute;
           ShopOwner.ClientMessage("|p3You have just been paid your minutely salary of "$PayPerMinute$"!");
           ToMonitorC.ShopOwner.Credits -= PayPerMinute;
           ToMonitorC.ShopOwner.ClientMessage("|cf88"$ShopOwner.PlayerReplicationInfo.PlayerName$" has been paid their minutely salary of "$PayPerMinute$"!");
           ToMonitorC.ShopOwner.ClientMessage("|p2NOTE ALL SALARY MONEY COMES FROM YOU.");
           SetTimer(60, False);
          }
          else
           return;
}

defaultproperties
{
     buttonLitTime=0.500000
     buttonSound1=Sound'DeusExSounds.Generic.Beep1'
     bInvincible=True
     ItemName="|p7Employee Button"
     bPushable=False
     Physics=PHYS_None
     RemoteRole=ROLE_SimulatedProxy
     Mesh=LodMesh'DeusExDeco.Button1'
     CollisionRadius=2.000000
     CollisionHeight=2.000000
     bCollideWorld=False
     bCollideActors=True
     bBlockActors=True
     Mass=5.000000
     Buoyancy=2.000000
}
